Index: content/firebug/lib.js
===================================================================
--- content/firebug/lib.js	(revision 16)
+++ content/firebug/lib.js	(working copy)
@@ -847,6 +847,20 @@
     return nodes;
 };
 
+this.getByXPath = function(doc, xpath, contextNode)
+{
+    var nodes = [];
+    var result = doc.evaluate(xpath, contextNode||doc, null, XPathResult.ANY_TYPE, null);
+    switch( result.resultType ) {
+        case result.STRING_TYPE:  return result.stringValue;
+        case result.NUMBER_TYPE:  return result.numberValue;
+        case result.BOOLEAN_TYPE: return result.booleanValue;
+    }
+    for (var item = result.iterateNext(); item; item = result.iterateNext())
+        nodes.push(item);
+    return nodes;
+}
+
 this.getRuleMatchingElements = function(rule, doc)
 {
     var css = rule.selectorText;
Index: content/firebug/commandLineAPI.js
===================================================================
--- content/firebug/commandLineAPI.js	(revision 16)
+++ content/firebug/commandLineAPI.js	(working copy)
@@ -48,11 +48,20 @@
         return FBL.getElementsBySelector(baseWindow.document, selector);
     };
     
-    this.$x = function(xpath)
+    this.$x = function(xpath, contextNode)
     {
-        return FBL.getElementsByXPath(baseWindow.document, xpath);
+        var doc = baseWindow.document;
+        if (contextNode)
+            doc = contextNode.ownerDocument;
+        return FBL.getByXPath(doc, xpath, contextNode);
     };
 
+    this.$X = function(xpath, contextNode)
+    {
+        var got = this.$x(xpath, contextNode);
+        return got instanceof Array ? got[0] : got;
+    };
+
     this.cd = function(object)
     {
         if (object instanceof Window)
